//---------------------------------------------------------------------------
#include <vcl.h>
#include <stdio.h>
#include "TUniverse.cpp"
#pragma hdrstop

#include "TSettingsBox.h"
#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CSPIN"
#pragma resource "*.dfm"
TSettingsBox *SettingsBox;
extern TUniverse *Universe;
extern int MaxFPS;
extern double MinRateMs;
double ALPHA, GAMMA;

//---------------------------------------------------------------------------
__fastcall TSettingsBox::TSettingsBox(TComponent* Owner)
	: TForm(Owner)
{
	EditGamma->Text = Float2String(Universe->Gamma, 10);
    EditAlpha->Text = Float2String(Universe->Alpha, 10);
    RxSliderAlpha->Position = trunc(Universe->Alpha*100);
    CheckDraw3D->Checked = Universe->GetDraw3D();
    SpinEditBrightness->Value = int(Universe->Brightness);
	SpinEditBrightness->Enabled = CheckDraw3D->Checked;
    SpinEditFPS->Value = MaxFPS;
    CheckBoxImpacts->Checked = Universe->DetectImpacts;
    RBtnRK2->Checked = (Universe->Method == 0);
    RBtnRK3->Checked = (Universe->Method == 1);
    RBtnRK4->Checked = (Universe->Method == 2);
    RBtnRK5->Checked = (Universe->Method == 3);
    RBtnRK6->Checked = (Universe->Method == 4);
    RBtnRK7->Checked = (Universe->Method == 5);
    RBtnRK8->Checked = (Universe->Method == 6);
    CheckBoxShowHint->Checked = MainForm->ShowHint;
    ALPHA = Universe->Alpha;
    GAMMA = Universe->Gamma;
}
//---------------------------------------------------------------------------
void __fastcall TSettingsBox::FormCloseQuery(TObject *Sender,
      bool &CanClose)
{
	Release();	
}
//---------------------------------------------------------------------------
void __fastcall TSettingsBox::BtnCancelClick(TObject *Sender)
{
	Close();
}
//---------------------------------------------------------------------------
void __fastcall TSettingsBox::RxSliderAlphaChange(TObject *Sender)
{
    if (!RxSliderAlpha->Focused()) return;
    ALPHA = double(RxSliderAlpha->Position)/(RxSliderAlpha->Max);
	EditAlpha->Text = Float2String(ALPHA, 10);
}
//---------------------------------------------------------------------------
void __fastcall TSettingsBox::EditAlphaExit(TObject *Sender)
{
	if (!EditAlpha->Modified) return;
    else EditAlpha->Modified = false;
	double Alpha = 0;
    //	     :
	if (!sscanf(EditAlpha->Text.c_str(), "%lf", &Alpha) || (EditAlpha->Text.Trim()).Length()==0) {
        EditAlpha->Text = Float2String(ALPHA,10);
        return;
    }
    if (Alpha < 0 || Alpha > 1) {
        EditAlpha->Text = Float2String(ALPHA,10);
        return;
    }
	//	  :
    ALPHA = Alpha;
    EditAlpha->Text = Float2String(Alpha, 10);
    RxSliderAlpha->Position = int(Alpha*100);
}
//---------------------------------------------------------------------------
void __fastcall TSettingsBox::EditAlphaKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
	if (Key == VK_RETURN) CheckBoxImpacts->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TSettingsBox::EditGammaExit(TObject *Sender)
{
	if (!EditGamma->Modified) return;
    else EditGamma->Modified = false;
	double Gamma = 0;
    //	     :
	if (!sscanf(EditGamma->Text.c_str(), "%lf", &Gamma) || (EditGamma->Text.Trim()).Length()==0) {
        EditGamma->Text = Float2String(GAMMA,10);
        return;
    }
    if (Gamma < 0) {
        EditGamma->Text = Float2String(GAMMA,10);
        return;
    }
	//	  :
    GAMMA = Gamma;
    EditGamma->Text = Float2String(Gamma, 10);
}
//---------------------------------------------------------------------------
void __fastcall TSettingsBox::EditGammaKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
	if (Key == VK_RETURN) RxSliderAlpha->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TSettingsBox::BtnOKClick(TObject *Sender)
{
	Universe->Alpha = ALPHA;
    Universe->Gamma = GAMMA;
    Universe->SetDraw3D(CheckDraw3D->Checked);
    Universe->DetectImpacts = CheckBoxImpacts->Checked;
    Universe->Brightness = Byte(SpinEditBrightness->Value);
    MaxFPS = SpinEditFPS->Value;
    MinRateMs = 1000.0/MaxFPS;
    if (RBtnRK2->Checked)      	 Universe->Method = 0;
    if (RBtnRK3->Checked)        Universe->Method = 1;
    if (RBtnRK4->Checked)        Universe->Method = 2;
    if (RBtnRK5->Checked)        Universe->Method = 3;
    if (RBtnRK6->Checked)        Universe->Method = 4;
    if (RBtnRK7->Checked)        Universe->Method = 5;
    if (RBtnRK8->Checked)        Universe->Method = 6;
    MainForm->ShowHint = CheckBoxShowHint->Checked;
    Universe->Draw();
    Close();
}
//---------------------------------------------------------------------------
void __fastcall TSettingsBox::SBtnGClick(TObject *Sender)
{
	GAMMA = 6.6732E-11;
	EditGamma->Text = Float2String(GAMMA, 10);
}
//---------------------------------------------------------------------------
void __fastcall TSettingsBox::CheckDraw3DClick(TObject *Sender)
{
	SpinEditBrightness->Enabled = CheckDraw3D->Checked;
}
//---------------------------------------------------------------------------

