#include <stdio.h>
#include <math.h>

// ----------------------------------------------------------------------------
//   :

class TTimeEx {
public:

	bool TimeDirection;		//    (false - )

	double	Seconds;
    int		Minutes;
    int		Hours;
    int		Days;
    int		Years;
    int		KYears;
    int		MYears;
    int		GYears;

    TTimeEx();
    void Init();
    void Increment(double);
    AnsiString Print();
};

// ----------------------------------------------------------------------------
// :

TTimeEx::TTimeEx()
{
    TimeDirection = true;
	Seconds = 0;  Minutes = 0;  Hours = 0;   Days = 0;
    Years = 0;    KYears = 0;   MYears = 0;  GYears = 0;
};

void TTimeEx::Init()
{
    TimeDirection = true;
	Seconds = 0;  Minutes = 0;  Hours = 0;   Days = 0;
    Years = 0;    KYears = 0;   MYears = 0;  GYears = 0;
};

// ----------------------------------------------------------------------------
// :

void TTimeEx::Increment(double dt)
{
	dt = (!TimeDirection) ? -dt : dt;

//	  :

	if (-2147483647 < dt && dt < 2147483647) {
		Seconds += dt;
		//   :
	    int Sec = (Seconds >= 0) ? int(Seconds) : int(Seconds) - (fmod(Seconds,1.0)!=0);
	//	  :
	    Seconds -= Sec;
		//   :
		int Min = (Sec >= 0) ? Sec/60 : Sec/60 - (Sec%60!=0);
	//	:
		Seconds += Sec - 60*Min;
	    if (!Min) return;
	    //   :
	    int Hr = (Minutes+Min >= 0) ? (Minutes+Min)/60 : (Minutes+Min)/60 - ((Minutes+Min)%60!=0);
	//	:
		Minutes += Min - 60*Hr;
	    if (!Hr) return;
	    //   :
	    int D = (Hours+Hr >= 0) ? (Hours+Hr)/24 : (Hours+Hr)/24 - ((Hours+Hr)%24!=0);
	//	:
		Hours += Hr - 24*D;
	    if (!D) return;
	    //   :
	    int Y = (Days+D >= 0) ? (Days+D)/365 : (Days+D)/365 - ((Days+D)%365!=0);
	//	:
		Days += D - 365*Y;
	    if (!Y) return;
	    //   :
	    int KY = (Years+Y >= 0) ? (Years+Y)/1000 : (Years+Y)/1000 - ((Years+Y)%1000!=0);
	//	:
		Years += Y - 1000*KY;
	    if (!KY) return;
	    //    :
	    int MY = (KYears+KY >= 0) ? (KYears+KY)/1000 : (KYears+KY)/1000 - ((KYears+KY)%1000!=0);
	//	:
		KYears += KY - 1000*MY;
	    if (!MY) return;
	    //    :
	    int GY = (MYears+MY >= 0) ? (MYears+MY)/1000 : (MYears+MY)/1000 - ((MYears+MY)%1000!=0);
	//	 :
		MYears += MY - 1000*GY;
	    if (!GY) return;
	    //    :
	    int TY = (GYears+GY >= 0) ? (GYears+GY)/1000 : (GYears+GY)/1000 - ((GYears+GY)%1000!=0);
	//	 :
		GYears += GY - 1000*TY;
    }

//	  :

	else {
		Seconds += dt;
		//   :
	    double Sec = floor(Seconds);
	//	  :
	    Seconds -= Sec;  Seconds = (Seconds>=0) ? Seconds : -Seconds;
		//   :
		double Min = floor(Sec/60);
	//	:
		Seconds += int(Sec - 60*Min);
	    if (Min==0) return;
	    //   :
	    double Hr = floor((Minutes+Min)/60);
	//	:
		Minutes += int(Min - 60*Hr);
	    if (Hr==0) return;
	    //   :
	    double D = floor((Hours+Hr)/24);
	//	:
		Hours += int(Hr - 24*D);
	    if (D==0) return;
	    //   :
	    double Y = floor((Days+D)/365);
	//	:
		Days += int(D - 365*Y);
	    if (Y==0) return;
	    //   :
	    double KY = floor((Years+Y)/1000);
	//	:
		Years += int(Y - 1000*KY);
	    if (KY==0) return;
	    //    :
	    double MY = floor((KYears+KY)/1000);
	//	:
		KYears += int(KY - 1000*MY);
	    if (MY==0) return;
	    //    :
	    double GY = floor((MYears+MY)/1000);
	//	 :
		MYears += int(MY - 1000*GY);
	    if (GY==0) return;
	    //    :
	    double TY = floor((GYears+GY)/1000);
	//	 :
		GYears += int(GY - 1000*TY);
    }
};

// ----------------------------------------------------------------------------
//   :

AnsiString TTimeEx::Print()
{
	char Buf[4];
    AnsiString Printed = "";
    sprintf(Buf, "%03d",  GYears);       Printed += AnsiString(Buf);  Printed += " ";
    sprintf(Buf, "%03d",  MYears);       Printed += AnsiString(Buf);  Printed += " ";
    sprintf(Buf, "%03d",  KYears);       Printed += AnsiString(Buf);  Printed += " ";
    sprintf(Buf, "%03d",   Years);       Printed += AnsiString(Buf);  Printed += ": ";
    sprintf(Buf, "%03d",    Days);       Printed += AnsiString(Buf);  Printed += ":";
    sprintf(Buf, "%02d",   Hours);       Printed += AnsiString(Buf);  Printed += ":";
    sprintf(Buf, "%02d", Minutes);       Printed += AnsiString(Buf);  Printed += ":";
    sprintf(Buf, "%02d", int(Seconds));  Printed += AnsiString(Buf);
    return Printed;
};
