
//      .   
//      (   ),
//           .

// ----------------------------------------------------------------------------
//   i-       Root.

void MountElement(int i, int Root, double *Criteria, int *Left, int *Right)
{
    //    :
    if (Criteria[i] < Criteria[Root]) {
    	//    , :
    	if (Left[Root] < 0) Left[Root] = i;
        //      :
        else MountElement(i, Left[Root], Criteria, Left, Right);
    }

    //    :
    else {
    	//    , :
    	if (Right[Root] < 0) Right[Root] = i;
        //      :
        else MountElement(i, Right[Root], Criteria, Left, Right);
    }
}

// ----------------------------------------------------------------------------
//   --    Root,  
//     .     
//  Order.

void DescendingOrder(int Root, int *Numbers, int *Left, int *Right, int *Order, int *i)
{
	// *i -   Order,    .
    //  :
    if (Right[Root] >= 0) DescendingOrder(Right[Root], Numbers, Left, Right, Order, i);
    // :
    Order[*i] = Numbers[Root];
    *i = *i + 1;
    //  :
    if (Left[Root] >= 0) DescendingOrder(Left[Root], Numbers, Left, Right, Order, i);
}

// ----------------------------------------------------------------------------
//   .     .
//   ,     .

int *TreeSort(int *Numbers, double *Criteria, int Count)
{
	if (Count<=0) return NULL;
    int i;

    //   :
    int *Left =  new int[Count];
    int *Right = new int[Count];
    int *Order = new int[Count];
    for (i=0; i<Count; i++) {
    	Left[i] = -1;  Right[i] = -1;
        Order[i] = Numbers[i];
    }

    //   :
    for (i=1; i<Count; i++) MountElement(i, 0, Criteria, Left, Right);

    int j = 0;
    //        :
    DescendingOrder(0, Numbers, Left, Right, Order, &j);

    //  :
    delete[] Left;  delete[] Right;

    //  :
    return Order;
}

