//---------------------------------------------------------------------------
#include <vcl.h>
#include <stdio.h>
#include <sys\timeb.h>
#pragma hdrstop

#include "Unit1.h"
#include "TSettingsBox.h"
#include "TGenBox.h"
#include "TCameraBox.h"
#include "TTimeBox.h"
#include "TTrajSettingsBox.h"
#include "TPlanetBox.h"
#include "TUniverse.cpp"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm *MainForm;

TUniverse *Universe;	// !

TColor LabelColor = TColor(0x00FFD7A0);//TColor(0x004FB8FF);

int NRand = 40;			//    
double TimeScale = 1;	//  
double TimeStep = 0.02;	//     
int XDigits = 12;		//       
int RDigits = 9;		//       
int MaxXDigits = 16;
int MaxRDigits = 12;
int MX, MY;				//    
int LastX, LastY;		//    
bool LeftMouse = false;	//    :
bool RightMouse = false;
bool Shft = false;
bool Ctrl = false;
bool Numpad0 = false;
bool Numpad2 = false;
bool Numpad4 = false;
bool Numpad5 = false;
bool Numpad6 = false;
bool Numpad8 = false;

bool NeedToDraw = false;//  

int PLAY;				//  
int SelectingRect;		//   
TRect SelRect;			//   
int OrigX, OrigY;		//  
int LastGen = NRand;	//    

struct	timeb t;		//   
double	RateMs;			//    , 
int		Frames;			//     FrameCluster
int		FrameCluster;	//      
double	WaitAPM;		//   , 
int		NumberAPM;		//      
int		MaxFPS = 80;	//  FPS
double	MinRateMs = 1000.0/MaxFPS;	//      , 
double	LastRateMs;
int		LastDifNumberAPM;

#include "Reflexes.cpp"

//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
	: TForm(Owner)
{
	randomize();
    DecimalSeparator = '.';
    MX = 0;  MY = 0;

	Panel->Width  = ClientWidth  - Panel->Left;
    Panel->Height = ClientHeight - Panel->Top;
    Image->Width  = Panel->Width;
    Image->Height = Panel->Height;
    Image->Picture->Bitmap->Width  = max(1,Image->Width);
    Image->Picture->Bitmap->Height = max(1,Image->Height);
    Image->Canvas->Font->Name = "Arial Cyr";
    Image->Canvas->Font->Size = 8;

    Universe = new TUniverse;
    Universe->Image = Image;
    Universe->SetDraw3D(0);
//    Universe->DetectImpacts = 1;
//    Universe->Alpha = 0.5;
    Universe->RandomPlanets(NRand,true,0,0,0,0,0,0,0,0);
    EditPlanets->Text = AnsiString(Universe->Count) + Body(Universe->Count);
    EditTime->Text = Universe->Time->Print();
/*
    for (int i=0; i<Universe->Count; i++) {
		Universe->Planets[i]->HasTrajectory = true;
    }
*/

    SelRect = Rect(0,0,0,0);

    Panel->Color = Universe->Color;
    LabelTime->Width = PanelTime->Width - 2*LabelTime->Left - 1;
    LabelFPS->Left = LabelTime->Left + LabelTime->Width - LabelFPS->Width;
    LabelTools->Width = PanelTools->Width - 2*LabelTools->Left - 1;
    LabelPlanet->Width = PanelPlanet->Width - 2*LabelPlanet->Left - 1;
    LabelUniverse->Width = PanelUniverse->Width - 2*LabelUniverse->Left - 1;
    LabelTime->Color = LabelColor;
    LabelFPS->Color = LabelColor;
    LabelTools->Color = LabelColor;
    LabelPlanet->Color = LabelColor;
    LabelUniverse->Color = LabelColor;
    EditTime->Color = MainForm->Color;
    EditPlanets->Color = MainForm->Color;

    LabelPlanet->Canvas->Font = LabelPlanet->Font;
    LabelPlanet->Caption = (PlanetName != "") ? AnsiString(" ") + ":  " + PlanetName : AnsiString(" ");
    ImagePlanet->Left = LabelPlanet->Left + (LabelPlanet->Width - LabelPlanet->Canvas->TextWidth(LabelPlanet->Caption))/2
                        - ImagePlanet->Width - 5;

    PLAY = 0;
    SelectingRect = 0;
    RateMs = 0;
    FrameCluster = 1;
    WaitAPM = 0;    NumberAPM = 0;
    LastRateMs = 0; LastDifNumberAPM = 0;

    FormResize(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormResize(TObject *Sender)
{
	Panel->Width  = ClientWidth  - Panel->Left;
    Panel->Height = ClientHeight - Panel->Top;

    Image->Width  = Panel->Width - Image->Left - 1;
    Image->Height = Panel->Height - Image->Top - 1;
    Image->Picture->Bitmap->Width  = max(1,Image->Width);
    Image->Picture->Bitmap->Height = max(1,Image->Height);

    PanelRight->Width = ClientWidth - PanelRight->Left;

    Universe->Draw();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ImageDblClick(TObject *Sender)
{
//	 :
	if (PLAY) return;

	int W = Image->Width;								//  
	int H = Image->Height;								//  
    double F = double(W)/2/tan(Universe->Camera->Phi);	//  
    double **R = Universe->Camera->R;					//  
    //   .. :
    double XR = MX - W/2;
    double YR = H/2 - MY;
    double ZR = -F;
    //   :
    double dX0 = PX - Universe->Camera->X0;
    double dY0 = PY - Universe->Camera->Y0;
    double dZ0 = PZ - Universe->Camera->Z0;
    double C = sqrt((dX0*dX0 + dY0*dY0 + dZ0*dZ0)/(XR*XR + YR*YR + F*F));
    C = max(C, 3*RADIUS/sqrt(XR*XR + YR*YR + F*F));
    XR *= C;  YR *= C;  ZR *= C;
    //   . ..:
    double X = R[0][0]*XR + R[1][0]*YR + R[2][0]*ZR + Universe->Camera->X0;
    double Y = R[0][1]*XR + R[1][1]*YR + R[2][1]*ZR + Universe->Camera->Y0;
    double Z = R[0][2]*XR + R[1][2]*YR + R[2][2]*ZR + Universe->Camera->Z0;

	if (Universe->NewPlanet(PanelColor->Color,RADIUS,MASS,X,Y,Z,VX,VY,VZ,true)) {
        Universe->SelectPlanet(Universe->Count-1);
        Universe->Selected = Universe->Count-1;
        Universe->Planets[Universe->Count-1]->HasTrajectory = SBtnTraj->Down;
        Universe->Planets[Universe->Count-1]->Trajectory->SetMaxPoints(MAXPOINTS);
        Universe->Planets[Universe->Count-1]->Trajectory->dL = DL;
    	Universe->Draw();
    }
    EditPlanets->Text = AnsiString(Universe->Count) + Body(Universe->Count);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SBtnDeleteClick(TObject *Sender)
{
//	  :
	if (PLAY) return;
	//	 :
    if (!SBtnGroup->Down) {
    	int Sel = Universe->Selected;
    	if (Sel > -1) {
        	Universe->DeletePlanet(Sel);
            Universe->Draw();
    	}
    }
    //	 :
    if (SBtnGroup->Down) {
    	int Count = Universe->Count;
        int i = 0;
        bool Redraw = false;
    	while (i<Count) {
        	if (Universe->Planets[i]->Selected) {
        		Universe->DeletePlanet(i);
                Redraw = true;
                Count--;
            }
            else i++;
        }
        if (Redraw) Universe->Draw();
    }
    Universe->Selected = -1;
    EditPlanets->Text = AnsiString(Universe->Count) + Body(Universe->Count);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SBtnDeleteAllClick(TObject *Sender)
{
	//	  :
	Universe->Init();
    Universe->Draw();
    EditPlanets->Text = AnsiString(Universe->Count) + Body(Universe->Count);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ImageMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    Panel->SetFocus();
	int Touched = Universe->Touched(X,Y);		//  

    if (Touched > -1) {
    	//     :
    	LoadPlanet(Touched);
        // /  :
        if (Universe->Planets[Touched]->Selected) Universe->Selected = Touched;
        else Universe->Selected = -1;
    }
    //   :
    else Universe->Selected = -1;

    //  :
    if (!RightMouse && Ctrl && !Shft) {
        if (Touched > -1) {
        	Screen->Cursor = crHandPoint;
            // /:
            if (Button==mbLeft)  {
            	Universe->SelectPlanet(Touched);
                // /  :
                if (Universe->Planets[Touched]->Selected) Universe->Selected = Touched;
                else Universe->Selected = -1;
            }
            // /:
            if (Button==mbRight) Universe->ActivatePlanet(Touched);
            if (!PLAY) Universe->Draw();
            return;
        }
        else Screen->Cursor = crDefault;
    }

	if (Button == mbLeft)  LeftMouse  = true;
    if (Button == mbRight) RightMouse = true;

    //	  :
    if (Button==mbLeft && !Ctrl && !Shft && SBtnSelect->Down) {
       	SelectingRect = 1;
        for (int i=0; i<Universe->Count; i++)
        	Universe->Planets[i]->Inside = false;
        SelRect.Left = X;   SelRect.Top = Y;
        SelRect.Right = X;  SelRect.Bottom = Y;
        OrigX = X;  OrigY = Y;
        Image->Canvas->Brush->Color = TColor(~(Universe->Color));
        Image->Canvas->DrawFocusRect(SelRect);
        return;
    }

    //  :
    if (LeftMouse &&  Ctrl &&  Shft) Screen->Cursor = crSizeWE;		// 
    if (LeftMouse && !Ctrl) Screen->Cursor = crHandPoint;			// 
    if (RightMouse) Screen->Cursor = crSizeNS;						//   
    SetCaptureControl(MainForm->Image);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ImageMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
	//	     :
    LastX = MX;  LastY = MY;
    MX = X;      MY = Y;
    if (LastX==X && LastY==Y) return;

    //  :
    double F = double(Image->Width)/2/tan(Universe->Camera->Phi);
    //  :
    double **R = Universe->Camera->R;

    //	 :
    if (SelectingRect) {
       	Image->Canvas->Brush->Color = TColor(~(Universe->Color));
        Image->Canvas->DrawFocusRect(SelRect);
       	if (X > OrigX) { SelRect.Left = OrigX; SelRect.Right = X; }
        else           { SelRect.Right = OrigX; SelRect.Left = X; }
       	if (Y > OrigY) { SelRect.Top = OrigY; SelRect.Bottom = Y; }
        else           { SelRect.Bottom = OrigY; SelRect.Top = Y; }
        Image->Canvas->DrawFocusRect(SelRect);
        Universe->UpdateSelectRect(&SelRect);
        return;
    }

    //	   :
    if ((!RightMouse && Ctrl && !Shft) || (!LeftMouse && !RightMouse)) {
    	int Touched = Universe->Touched(X,Y);
        if (Touched > -1) Screen->Cursor = crHandPoint;
        else Screen->Cursor = crDefault;
    	goto DRAW;
    }

    //	:
    if (LeftMouse && !Ctrl) {
    	double L = sqrt((X-LastX)*(X-LastX) + (LastY-Y)*(LastY-Y) + F*F);
        //	   :
       	bool HasCenter = false;
        if (Universe->Camera->RotateSight)
           	for (int i=0; i<Universe->Count; i++)
           		if (Universe->Planets[i]->Selected) {HasCenter = true; break;}
        //     :
        double sx = (LastY-Y)/L;
        double sy = (LastX-X)/L;
        //    :
        double dX0 = Universe->Camera->dX0;
        double dY0 = Universe->Camera->dY0;
        double dZ0 = Universe->Camera->dZ0;
        //    X:
        double Wx = Universe->Camera->R[0][0];
        double Wy = Universe->Camera->R[0][1];
        double Wz = Universe->Camera->R[0][2];
        Universe->Camera->RotateAround(Wx,Wy,Wz,(1 + HasCenter)*asin(sx));
        //    Y:
        Wx = Universe->Camera->R[1][0];
        Wy = Universe->Camera->R[1][1];
        Wz = Universe->Camera->R[1][2];
        Universe->Camera->RotateAround(Wx,Wy,Wz,(1 + HasCenter)*asin(sy));
        //    :
        if (HasCenter) {
			double Xc=0, Yc=0, Zc=0;		//    
   			double m, M = 0;				//  
   			for (int i=0; i<Universe->Count; i++)
				if (Universe->Planets[i]->Selected) {
                   	m = Universe->Planets[i]->Mass;
           			Xc += (Universe->Planets[i]->X)*m;
           			Yc += (Universe->Planets[i]->Y)*m;
           			Zc += (Universe->Planets[i]->Z)*m;
       				M += m;
       			}
   			if (M > MINDOUBLE) {
   				Xc /= M;  Yc /= M;  Zc /= M;
       			Universe->Camera->X0 = Xc + Universe->Camera->dX0;
       			Universe->Camera->Y0 = Yc + Universe->Camera->dY0;
       			Universe->Camera->Z0 = Zc + Universe->Camera->dZ0;
   			}
        }
        //  ,   :
        else {
        	Universe->Camera->dX0 = dX0;
        	Universe->Camera->dY0 = dY0;
        	Universe->Camera->dZ0 = dZ0;
        }
        NeedToDraw = true;
    }

    //	:
    if (RightMouse && !Shft) {
    	double Speed = Universe->Camera->Speed;
	    //      :
	    if (Universe->Camera->SpeedRelative) {
	    	bool HasCenter = false;
	    	for (int i=0; i<Universe->Count; i++)
	        	if (Universe->Planets[i]->Selected) {HasCenter = true; break;}
	        if (HasCenter) {
	    		double L = sqrt((Universe->Camera->dX0)*(Universe->Camera->dX0) +
	            	            (Universe->Camera->dY0)*(Universe->Camera->dY0) +
	        	                (Universe->Camera->dZ0)*(Universe->Camera->dZ0) );
	        	Speed = L;
	        }
	    }
    	//  :
    	double s = Speed*double(LastY-Y)/Image->Height;
        //     . . .:
        double dX0 = R[2][0]*s;
        double dY0 = R[2][1]*s;
        double dZ0 = R[2][2]*s;
        Universe->Camera->X0 -= dX0;  Universe->Camera->dX0 -= dX0;
        Universe->Camera->Y0 -= dY0;  Universe->Camera->dY0 -= dY0;
        Universe->Camera->Z0 -= dZ0;  Universe->Camera->dZ0 -= dZ0;
        NeedToDraw = true;
    }

    //	:
    if (LeftMouse && Ctrl && Shft) {
        //     :
        double s = sin(M_PI*double(X-LastX)/Image->Width);
        double c = sqrt(1-s*s);
        //  :
		double R0[3][3] = {{c,  -s,  0},
                           {s,   c,  0},
                           {0,   0,  1} };
        //   :
        double R1[3][3];
        int i,j,k;
        for (i=0; i<3; i++)
        	for (j=0; j<3; j++) {
            	R1[i][j] = 0;
            	for (k=0; k<3; k++) R1[i][j] += R0[i][k]*R[k][j];
            }
        //  :
        for (i=0;i<3;i++)  for (j=0;j<3;j++)  R[i][j] = R1[i][j];
        NeedToDraw = true;
    }

    //	:
    if (RightMouse && Shft) {
    	double F2 = F*pow(10,double(LastY - Y)/Image->Height);
        double F0 = double(Image->Width)/2/tan(Universe->Camera->MaxPhi);
        double Phi2 = atan(Image->Width/2/F2);
        Phi2 = (Phi2 <= Universe->Camera->MaxPhi) ? Phi2 : Universe->Camera->MaxPhi;
        F2   = double(Image->Width)/2/tan(Phi2);
        Universe->Camera->Phi = Phi2;
        EditZoom->Text = Float2String(F2/F0,8);
        NeedToDraw = true;
    }

DRAW:

    //	:
	if (!PLAY && NeedToDraw) Universe->Draw();
    NeedToDraw = false;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ImageMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
	if (Button == mbLeft)  LeftMouse  = false;
    if (Button == mbRight) RightMouse = false;

    //	  :
    if (SelectingRect && Button==mbLeft) {
       	Image->Canvas->Brush->Color = TColor(~(Universe->Color));
        Image->Canvas->DrawFocusRect(SelRect);
        SelectingRect = 0;
    }
    if (SelectingRect) return;

    //  :
    if ((LeftMouse && Ctrl && !Shft) || (!LeftMouse && !RightMouse)) {
    	int Touched = Universe->Touched(X,Y);					//  
        if (Touched > -1) Screen->Cursor = crHandPoint;
        else Screen->Cursor = crDefault;
    }
    if (LeftMouse &&  Ctrl &&  Shft) Screen->Cursor = crSizeWE;	// 
    if (LeftMouse && !Ctrl) Screen->Cursor = crHandPoint;		// 
    if (RightMouse) Screen->Cursor = crSizeNS;					//   
    if (!LeftMouse && !RightMouse) ReleaseCapture();
    else SetCaptureControl(MainForm->Image);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SBtnPlayClick(TObject *Sender)
{
	double ClusterTime = 333;			//    , 
	int    ts,tms;						//    , 
    int i;

    Screen->Cursor = crDefault;
    SBtnDelete->Enabled = false;
    SBtnDeleteAll->Enabled = false;
    Universe->Design = false;
	PLAY = 1;

	ts = 0; tms = 0;
    Frames = 0;
	while (PLAY) {
    	//	 FrameCluster     :
        if (Frames == 0) {
			ftime(&t);
			RateMs = (ts>0) ? (1000*(t.time - ts) + t.millitm-tms)/double(FrameCluster) : RateMs;
            //	      RateMs -   :
			if (LastDifNumberAPM != 0) {
            	WaitAPM = (RateMs - LastRateMs)/LastDifNumberAPM;
                LastDifNumberAPM = 0;
            }
            //	 RateMs      
            //	   :
			if (RateMs>0 && RateMs < MinRateMs) {
                LastRateMs = RateMs;
                LastDifNumberAPM = (WaitAPM>MINDOUBLE) ? ceil((MinRateMs-RateMs)/WaitAPM) : 1000;
                NumberAPM += LastDifNumberAPM;
            	RateMs = MinRateMs;
            }
            //	 RateMs    MinRateMs+5
            //	(    ):
            if (RateMs>0 && RateMs > MinRateMs+5 && NumberAPM>0) {
                LastRateMs = RateMs;
                LastDifNumberAPM = -((WaitAPM>MINDOUBLE) ? floor((RateMs-MinRateMs)/WaitAPM) : 1000);
                LastDifNumberAPM = (NumberAPM + LastDifNumberAPM > 0) ? LastDifNumberAPM : -NumberAPM;
                NumberAPM += LastDifNumberAPM;
                RateMs = MinRateMs;
            }
            //	  FrameCluster,  ClusterTime:
			FrameCluster = (ts>0 && RateMs>MINDOUBLE && ClusterTime>0) ? ceil(ClusterTime/RateMs) : ((RateMs==0 || ClusterTime==0) ? 2*FrameCluster : FrameCluster);
			ts = t.time; tms = t.millitm;
            //	   :
        	if (RateMs>1.7E-305) LabelFPS->Caption = FloatToStrF(1000/RateMs,ffFixed,4,0) + " fps";
            EditTime->Text = Universe->Time->Print();
			LoadPlanet(Universe->Active);
        }
    	Frames = (Frames+1)%FrameCluster;
        //	  :
    	Universe->NextStep(0.001*RateMs*TimeScale);
        if (!SelectingRect) StrafeCamera(0.001*RateMs);
		Universe->Draw();
        if (SelectingRect) {
        	Image->Canvas->Brush->Color = TColor(~(Universe->Color));
            Image->Canvas->DrawFocusRect(SelRect);
        }
		Application->ProcessMessages();
        //	   NumberAPM     RateMs:
		for (i=0;i<NumberAPM;i++) Application->ProcessMessages();
    }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SBtnStopClick(TObject *Sender)
{
	PLAY = 0;
    Universe->Design = true;
    Universe->Draw();
    LoadPlanet(Universe->Active);
    EditTime->Text = Universe->Time->Print();
    SBtnDelete->Enabled = true;
    SBtnDeleteAll->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
	PLAY = 0;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SBtnSettingsClick(TObject *Sender)
{
    //  ,  :
    PLAY = !PLAY;
    Application->CreateForm(__classid(TSettingsBox), &SettingsBox);
	SettingsBox->ShowModal();
    //    , :
    if (!PLAY) SBtnPlayClick(Sender);
    else PLAY = 0;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SBtnGenerateClick(TObject *Sender)
{
    //  ,  :
    PLAY = !PLAY;
    if (EditZoom->Focused()) { EditZoomExit(Sender); EditZoom->SelectAll(); }
    Application->CreateForm(__classid(TGenBox), &GenBox);
	GenBox->ShowModal();
    Universe->Draw();
    EditPlanets->Text = AnsiString(Universe->Count) + Body(Universe->Count);
    //    , :
    if (!PLAY) SBtnPlayClick(Sender);
    else PLAY = 0;
    if (!PLAY) Universe->Draw();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::TimerTimer(TObject *Sender)
{
//	   :
	if (PLAY) return;
	if (NeedToDraw) Universe->Draw();
    NeedToDraw = false;
    if (!Panel->Focused() || SelectingRect) return;
    StrafeCamera(double(Timer->Interval)/1000);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SBtnDeselectClick(TObject *Sender)
{
	Universe->DeselectAll();
    NeedToDraw = true;	
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SBtnDeactivateClick(TObject *Sender)
{
	Universe->ActivatePlanet(Universe->Active);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SBtnCameraClick(TObject *Sender)
{
    //  ,  :
    PLAY = !PLAY;
    if (EditZoom->Focused()) { EditZoomExit(Sender); EditZoom->SelectAll(); }
    Application->CreateForm(__classid(TCameraBox), &CameraBox);
	CameraBox->ShowModal();
    //    , :
    if (!PLAY) SBtnPlayClick(Sender);
    else PLAY = 0;
    if (!PLAY) Universe->Draw();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SBtnTimeClick(TObject *Sender)
{
    //  ,  :
    PLAY = !PLAY;
    if (EditZoom->Focused()) { EditZoomExit(Sender); EditZoom->SelectAll(); }
    Application->CreateForm(__classid(TTimeBox), &TimeBox);
	TimeBox->ShowModal();
    //    , :
    if (!PLAY) SBtnPlayClick(Sender);
    else PLAY = 0;
    EditTime->Text = Universe->Time->Print();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SBtnStepForwardClick(TObject *Sender)
{
//	 :
	if (PLAY) {
    	SBtnStopClick(Sender);
        SBtnStop->Down = true;
    }
    Universe->NextStep(TimeStep);
    Universe->Draw();
    EditTime->Text = Universe->Time->Print();
    LoadPlanet(Universe->Active);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SBtnStepBackClick(TObject *Sender)
{
//	 :
	if (PLAY) {
    	SBtnStopClick(Sender);
        SBtnStop->Down = true;
    }
	for (int i=0; i<Universe->Count; i++) {		//  
    	Universe->Planets[i]->Vx = -Universe->Planets[i]->Vx;
    	Universe->Planets[i]->Vy = -Universe->Planets[i]->Vy;
    	Universe->Planets[i]->Vz = -Universe->Planets[i]->Vz;
    	Universe->Planets[i]->NextVx = -Universe->Planets[i]->NextVx;
    	Universe->Planets[i]->NextVy = -Universe->Planets[i]->NextVy;
    	Universe->Planets[i]->NextVz = -Universe->Planets[i]->NextVz;
    }
    Universe->Time->TimeDirection = !Universe->Time->TimeDirection;
    Universe->NextStep(TimeStep);				// 
	for (int i=0; i<Universe->Count; i++) {		//  
    	Universe->Planets[i]->Vx = -Universe->Planets[i]->Vx;
    	Universe->Planets[i]->Vy = -Universe->Planets[i]->Vy;
    	Universe->Planets[i]->Vz = -Universe->Planets[i]->Vz;
    	Universe->Planets[i]->NextVx = -Universe->Planets[i]->NextVx;
    	Universe->Planets[i]->NextVy = -Universe->Planets[i]->NextVy;
    	Universe->Planets[i]->NextVz = -Universe->Planets[i]->NextVz;
    }
    Universe->Time->TimeDirection = !Universe->Time->TimeDirection;
    Universe->Draw();
    EditTime->Text = Universe->Time->Print();
    LoadPlanet(Universe->Active);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SBtnSaveClick(TObject *Sender)
{
//	 ,  :
    PLAY = !PLAY;
    if (EditZoom->Focused()) { EditZoomExit(Sender); EditZoom->SelectAll(); }

BACK:

	SaveDialog->FileName="";
    if (!SaveDialog->Execute()) {
    	if (!PLAY) SBtnPlayClick(Sender);
	    else PLAY = 0;
    	return;
    }
    AnsiString FileName = SaveDialog->FileName;

//	  :
    if (!FileName.IsEmpty()) {
    	//	 :
        int pos = FileName.LastDelimiter(".");
        int posSlash = FileName.LastDelimiter("\\");
        if (pos != 0 && posSlash < pos) FileName.Delete(pos, FileName.Length()-pos+1);
        FileName = FileName + ".uni";
        //	   :
        if (FileExists(FileName)) {
            int button = Application->MessageBox((AnsiString("  : ") +
                   FileName + "\n?").c_str(), "!", MB_YESNOCANCEL);
            if (button == IDNO) goto BACK;
            if (button == IDCANCEL) {
			    if (!PLAY) SBtnPlayClick(Sender);
			    else PLAY = 0;
            	return;
            }
        }
    }

//	 () :
    FILE *File = fopen(FileName.c_str(), "wt");
    if (File == NULL) {
    	Application->MessageBox(("      " + FileName + "!").c_str(), "", MB_OK);
    	if (!PLAY) SBtnPlayClick(Sender);
	    else PLAY = 0;
        return;
    }

//	   :
	fprintf(File, "%1.18G ( )\n", Universe->Gamma);
	fprintf(File, "%1.18G (  )\n", Universe->Alpha);
	fprintf(File, "%d ( )\n", Universe->Method);
	fprintf(File, "%d (  )\n", Universe->DetectImpacts);
	fprintf(File, "%d ( )\n", int(Universe->Color));
    //	  :
	fprintf(File, "\n :\n%1.18G ()\n", Universe->Time->Seconds);
	fprintf(File, "%d ()\n", Universe->Time->Minutes);
	fprintf(File, "%d ()\n", Universe->Time->Hours);
	fprintf(File, "%d ()\n", Universe->Time->Days);
	fprintf(File, "%d ()\n", Universe->Time->Years);
	fprintf(File, "%d ()\n", Universe->Time->KYears);
	fprintf(File, "%d ( )\n", Universe->Time->MYears);
	fprintf(File, "%d ( )\n", Universe->Time->GYears);
	fprintf(File, "%1.18G ( )\n", TimeScale);
	fprintf(File, "%1.18G (  , )\n", TimeStep);

    //	:
	fprintf(File, "\n:\n%1.18G\ %1.18G %1.18G ()\n", Universe->Camera->X0,Universe->Camera->Y0,Universe->Camera->Z0);
	int i,j;
    fprintf(File, " :\n");
    for (i=0; i<3; i++) {
    	for (j=0; j<3; j++) fprintf(File, "%1.17G ", Universe->Camera->R[i][j]);
        fprintf(File, "\n");
    }
	fprintf(File, "\n%1.18G\ %1.18G %1.18G (   )\n", Universe->Camera->dX0,Universe->Camera->dY0,Universe->Camera->dZ0);
	fprintf(File, "%1.18G (   , )\n", Universe->Camera->Phi);
	fprintf(File, "%1.18G (    , )\n", Universe->Camera->MaxPhi);
	fprintf(File, "%1.18G (  /)\n", Universe->Camera->Speed);
	fprintf(File, "%1.18G (   )\n", Universe->Camera->StrafeSpeed);
	fprintf(File, "%d (  )\n", Universe->Camera->SpeedRelative);
	fprintf(File, "%d (   )\n", Universe->Camera->RotateSight);
	fprintf(File, "%d (    )\n", Universe->Camera->RotateWith);
	fprintf(File, "%d (  )\n", Universe->Camera->DrawAxes);
	fprintf(File, "%d (  )\n", Universe->Camera->DrawPoint);
    //	 :
	fprintf(File, "\n:\n%d ( )\n", Universe->Count);
	fprintf(File, "%d ( )\n", Universe->Active);
	fprintf(File, ", , X,Y,Z, Vx,Vy,Vz, , , , , ,  , :\n");
    for (i=0; i<Universe->Count; i++) {
		fprintf(File, "%1.18G %1.18G %1.18G %1.18G %1.18G %1.18G %1.18G %1.18G %d %d %d %d %1.18G %d %s\n",
                                                       Universe->Planets[i]->Mass, Universe->Planets[i]->Radius,
                                                       Universe->Planets[i]->X, Universe->Planets[i]->Y, Universe->Planets[i]->Z,
                                                       Universe->Planets[i]->Vx, Universe->Planets[i]->Vy, Universe->Planets[i]->Vz,
                                                       Universe->Planets[i]->Color, Universe->Planets[i]->Selected,
                                                       Universe->Planets[i]->HasTrajectory, Universe->Planets[i]->Trajectory->GetMaxPoints(),
                                                       Universe->Planets[i]->Trajectory->dL, Universe->Planets[i]->ShowName,
                                                       ("#"+Universe->Planets[i]->Name).c_str());
        //	 :
        if (Universe->Planets[i]->HasTrajectory) {
        	T3DPoint *P = Universe->Planets[i]->Trajectory->First;
        	while (P!=NULL) {
            	fprintf(File, "%1.18G %1.18G %1.18G\n", P->X, P->Y, P->Z);
                P = P->Next;
            }
        }
    }

    fclose(File);

//	   , :
    if (!PLAY) SBtnPlayClick(Sender);
    else PLAY = 0;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SBtnLoadClick(TObject *Sender)
{
//	 ,  :
    PLAY = !PLAY;
    if (EditZoom->Focused()) { EditZoomExit(Sender); EditZoom->SelectAll(); }

//    :
	TUniverse *Uni = new TUniverse;
    Uni->Image = Image;
    Uni->SetDraw3D(Universe->GetDraw3D());
    bool Error = false;

//    :
	if (!OpenDialog->Execute()) {
    	delete Uni;
        if (!PLAY) SBtnPlayClick(Sender);
    	else PLAY = 0;
 		return;
    }
    if (!FileExists(OpenDialog->FileName)) {
    	Application->MessageBox((" " + OpenDialog->FileName + "  !").c_str(), "", MB_OK);
        delete Uni;
    	if (!PLAY) SBtnPlayClick(Sender);
	    else PLAY = 0;
        return;
    }
//	:
    FILE *File = fopen(OpenDialog->FileName.c_str(), "rt");
    if (File == NULL) {
    	Application->MessageBox(("   " + OpenDialog->FileName + " !").c_str(), "", MB_OK);
        delete Uni;
    	if (!PLAY) SBtnPlayClick(Sender);
	    else PLAY = 0;
        return;
    }

//	 :
    char buf[1024];
    if (NULL == fgets(buf,1023,File)) {Error = true; goto EXIT;}
    if (1 > sscanf(buf, "%lf", &(Uni->Gamma))) {Error = true; goto EXIT;}
    if (NULL == fgets(buf,1023,File)) {Error = true; goto EXIT;}
    if (1 > sscanf(buf, "%lf", &(Uni->Alpha))) {Error = true; goto EXIT;}
    if (NULL == fgets(buf,1023,File)) {Error = true; goto EXIT;}
    if (1 > sscanf(buf, "%D", &(Uni->Method))) {Error = true; goto EXIT;}
    if (NULL == fgets(buf,1023,File)) {Error = true; goto EXIT;}
    if (1 > sscanf(buf, "%D", &(Uni->DetectImpacts))) {Error = true; goto EXIT;}
    if (NULL == fgets(buf,1023,File)) {Error = true; goto EXIT;}
    if (1 > sscanf(buf, "%D", &(Uni->Color))) {Error = true; goto EXIT;}
    //	  :
    fgets(buf,1023,File);  fgets(buf,1023,File);
    if (NULL == fgets(buf,1023,File)) {Error = true; goto EXIT;}
    if (1 > sscanf(buf, "%lf", &(Uni->Time->Seconds))) {Error = true; goto EXIT;}
    if (NULL == fgets(buf,1023,File)) {Error = true; goto EXIT;}
    if (1 > sscanf(buf, "%D", &(Uni->Time->Minutes))) {Error = true; goto EXIT;}
    if (NULL == fgets(buf,1023,File)) {Error = true; goto EXIT;}
    if (1 > sscanf(buf, "%D", &(Uni->Time->Hours))) {Error = true; goto EXIT;}
    if (NULL == fgets(buf,1023,File)) {Error = true; goto EXIT;}
    if (1 > sscanf(buf, "%D", &(Uni->Time->Days))) {Error = true; goto EXIT;}
    if (NULL == fgets(buf,1023,File)) {Error = true; goto EXIT;}
    if (1 > sscanf(buf, "%D", &(Uni->Time->Years))) {Error = true; goto EXIT;}
    if (NULL == fgets(buf,1023,File)) {Error = true; goto EXIT;}
    if (1 > sscanf(buf, "%D", &(Uni->Time->KYears))) {Error = true; goto EXIT;}
    if (NULL == fgets(buf,1023,File)) {Error = true; goto EXIT;}
    if (1 > sscanf(buf, "%D", &(Uni->Time->MYears))) {Error = true; goto EXIT;}
    if (NULL == fgets(buf,1023,File)) {Error = true; goto EXIT;}
    if (1 > sscanf(buf, "%D", &(Uni->Time->GYears))) {Error = true; goto EXIT;}
    if (NULL == fgets(buf,1023,File)) {Error = true; goto EXIT;}
    if (1 > sscanf(buf, "%lf", &TimeScale)) {Error = true; goto EXIT;}
    if (NULL == fgets(buf,1023,File)) {Error = true; goto EXIT;}
    if (1 > sscanf(buf, "%lf", &TimeStep)) {Error = true; goto EXIT;}
    //	:
    fgets(buf,1023,File);  fgets(buf,1023,File);
    if (NULL == fgets(buf,1023,File)) {Error = true; goto EXIT;}
    if (3 > sscanf(buf, "%lf %lf %lf", &(Uni->Camera->X0),
                                       &(Uni->Camera->Y0),
                                       &(Uni->Camera->Z0))) {Error = true; goto EXIT;}
    int i;  fgets(buf,1023,File);
    for (i=0; i<3; i++) {
    	if (NULL == fgets(buf,1023,File)) {Error = true; goto EXIT;}
        if (3 > sscanf(buf, "%lf %lf %lf", &(Uni->Camera->R[i][0]),
                                           &(Uni->Camera->R[i][1]),
                                           &(Uni->Camera->R[i][2]))) {Error = true; goto EXIT;}
    }
    fgets(buf,1023,File);
    if (NULL == fgets(buf,1023,File)) {Error = true; goto EXIT;}
    if (3 > sscanf(buf, "%lf %lf %lf", &(Uni->Camera->dX0),
                                       &(Uni->Camera->dY0),
                                       &(Uni->Camera->dZ0))) {Error = true; goto EXIT;}
    if (NULL == fgets(buf,1023,File)) {Error = true; goto EXIT;}
    if (1 > sscanf(buf, "%lf", &(Uni->Camera->Phi))) {Error = true; goto EXIT;}
    if (NULL == fgets(buf,1023,File)) {Error = true; goto EXIT;}
    if (1 > sscanf(buf, "%lf", &(Uni->Camera->MaxPhi))) {Error = true; goto EXIT;}
    if (NULL == fgets(buf,1023,File)) {Error = true; goto EXIT;}
    if (1 > sscanf(buf, "%lf", &(Uni->Camera->Speed))) {Error = true; goto EXIT;}
    if (NULL == fgets(buf,1023,File)) {Error = true; goto EXIT;}
    if (1 > sscanf(buf, "%lf", &(Uni->Camera->StrafeSpeed))) {Error = true; goto EXIT;}
    if (NULL == fgets(buf,1023,File)) {Error = true; goto EXIT;}
    if (1 > sscanf(buf, "%D", &(Uni->Camera->SpeedRelative))) {Error = true; goto EXIT;}
    if (NULL == fgets(buf,1023,File)) {Error = true; goto EXIT;}
    if (1 > sscanf(buf, "%D", &(Uni->Camera->RotateSight))) {Error = true; goto EXIT;}
    if (NULL == fgets(buf,1023,File)) {Error = true; goto EXIT;}
    if (1 > sscanf(buf, "%D", &(Uni->Camera->RotateWith))) {Error = true; goto EXIT;}
    if (NULL == fgets(buf,1023,File)) {Error = true; goto EXIT;}
    if (1 > sscanf(buf, "%D", &(Uni->Camera->DrawAxes))) {Error = true; goto EXIT;}
    if (NULL == fgets(buf,1023,File)) {Error = true; goto EXIT;}
    if (1 > sscanf(buf, "%D", &(Uni->Camera->DrawPoint))) {Error = true; goto EXIT;}
    //	 :
    fgets(buf,1023,File);  fgets(buf,1023,File);
    int Count, Active;
    if (NULL == fgets(buf,1023,File)) {Error = true; goto EXIT;}
    if (1 > sscanf(buf, "%D", &Count)) {Error = true; goto EXIT;}
    if (NULL == fgets(buf,1023,File)) {Error = true; goto EXIT;}
    if (1 > sscanf(buf, "%D", &Active)) {Error = true; goto EXIT;}
    fgets(buf,1023,File);
    if (Count < 0) {Error = true; goto EXIT;}
    double Mass, Radius, sX,sY,sZ, sVx,sVy,sVz, dL;
    int Color, Selected, HasTraj, MaxPoints, ShowName;
    bool ReadAhead; ReadAhead = false;
    for (i=0; i<Count; i++) {
    	if (!ReadAhead) {
    		if (NULL == fgets(buf,1023,File)) {Error = true; goto EXIT;}
        }
        else {
        	if (NULL == buf) {Error = true; goto EXIT;}
            ReadAhead = false;
        }
    	if (14 > sscanf(buf, "%lf %lf %lf %lf %lf %lf %lf %lf %D %D %D %D %lf %D",
            &Mass, &Radius, &sX,&sY,&sZ, &sVx,&sVy,&sVz, &Color, &Selected, &HasTraj, &MaxPoints, &dL, &ShowName)) {Error = true; goto EXIT;}
        if (!Uni->NewPlanet(TColor(Color), Radius, Mass, sX,sY,sZ, sVx,sVy,sVz,false))
        	Application->MessageBox("   !\n   .", "",MB_OK);
        else {
        	Uni->Planets[Uni->Count-1]->Selected = Selected;
            if (Uni->Count-1 == Active) {
            	Uni->Planets[Active]->Active = true;
                Uni->Active = Active;
            }
            Uni->Planets[Uni->Count-1]->HasTrajectory = HasTraj;
            Uni->Planets[Uni->Count-1]->Trajectory->SetMaxPoints(MaxPoints);
            Uni->Planets[Uni->Count-1]->Trajectory->dL = dL;
            Uni->Planets[Uni->Count-1]->ShowName = ShowName;
            Uni->Planets[Uni->Count-1]->Name = AnsiString(buf);
            int pos = Uni->Planets[Uni->Count-1]->Name.Pos("#");
            if (pos > 0) {
            	Uni->Planets[Uni->Count-1]->Name.Delete(1,pos);
                Uni->Planets[Uni->Count-1]->Name.Delete(Uni->Planets[Uni->Count-1]->Name.Length(),1);
                Uni->Planets[Uni->Count-1]->Name.Trim();
            }
            else Uni->Planets[Uni->Count-1]->Name = "";
            //	 :
            if (HasTraj) {
                double tX,tY,tZ, D;
            	do {
    				if (NULL == fgets(buf,1023,File)) break;
                    if (3 != sscanf(buf, "%lf %lf %lf %lf", &tX,&tY,&tZ,&D)) break;
                    Uni->Planets[Uni->Count-1]->Trajectory->Put(tX,tY,tZ);
                } while(true);
                ReadAhead = true;
            }
        }
    }

//	 :
	Uni->Gamma = fabs(Uni->Gamma);
	Uni->Alpha = fabs(Uni->Alpha);  Uni->Alpha = (Uni->Alpha <= 1) ? Uni->Alpha : 1;
    Uni->DetectImpacts = (Uni->DetectImpacts==0 || Uni->DetectImpacts==1) ? Uni->DetectImpacts : 1;
    Uni->Time->Seconds = fabs(Uni->Time->Seconds);  Uni->Time->Seconds = (Uni->Time->Seconds <= 59) ? Uni->Time->Seconds : 59;
    Uni->Time->Minutes = abs(Uni->Time->Minutes);  Uni->Time->Minutes = (Uni->Time->Minutes <= 59) ? Uni->Time->Minutes : 59;
    Uni->Time->Hours = abs(Uni->Time->Hours);  Uni->Time->Hours = (Uni->Time->Hours <= 23) ? Uni->Time->Hours : 23;
    Uni->Time->Days = abs(Uni->Time->Days);  Uni->Time->Days = (Uni->Time->Days <= 364) ? Uni->Time->Days : 364;
    Uni->Time->Years = abs(Uni->Time->Years);  Uni->Time->Years = (Uni->Time->Years <= 999) ? Uni->Time->Years : 999;
    Uni->Time->KYears = abs(Uni->Time->KYears);  Uni->Time->KYears = (Uni->Time->KYears <= 999) ? Uni->Time->KYears : 999;
    Uni->Time->MYears = abs(Uni->Time->MYears);  Uni->Time->MYears = (Uni->Time->MYears <= 999) ? Uni->Time->MYears : 999;
    Uni->Time->GYears = abs(Uni->Time->GYears);  Uni->Time->GYears = (Uni->Time->GYears <= 999) ? Uni->Time->GYears : 999;
    Uni->Camera->MaxPhi = fabs(Uni->Camera->MaxPhi);  Uni->Camera->MaxPhi = (Uni->Camera->MaxPhi < M_PI/2) ? Uni->Camera->MaxPhi : M_PI/6;
    Uni->Camera->Phi = fabs(Uni->Camera->Phi);  Uni->Camera->Phi = (Uni->Camera->Phi <= Uni->Camera->MaxPhi) ? Uni->Camera->Phi : Uni->Camera->MaxPhi;

EXIT:

    if (Error) {
    	delete Uni;				//	  
        Application->MessageBox("      !", "", MB_OK);
    }
    else {
    	try {
    		delete Universe;	//	  
        }	catch(...){};
        Universe = Uni;			//	  
    	EditPlanets->Text = AnsiString(Universe->Count) + Body(Universe->Count);
    	EditTime->Text = Universe->Time->Print();
        ZOOM = tan(Universe->Camera->MaxPhi)/tan(Universe->Camera->Phi);
        EditZoom->Text = Float2String(ZOOM,8);
        LoadPlanet(Universe->Active);
    }
    fclose(File);

//	   , :
    if (!PLAY) SBtnPlayClick(Sender);
    else PLAY = 0;
    if (!PLAY) Universe->Draw();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SBtnTrajSettingsClick(TObject *Sender)
{
    //  ,  :
    PLAY = !PLAY;
    if (EditZoom->Focused()) { EditZoomExit(Sender); EditZoom->SelectAll(); }
    Application->CreateForm(__classid(TTrajSettingsBox), &TrajSettingsBox);
	TrajSettingsBox->ShowModal();
    //    , :
    if (!PLAY) SBtnPlayClick(Sender);
    else PLAY = 0;
    if (!PLAY) Universe->Draw();
}
//---------------------------------------------------------------------------
